Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.core.runtime
Class Node

    java.lang.Object
      oracle.ifs.core.runtime.Node

All Implemented Interfaces:
  IfsEventHandler, NodeInterface, TimerContext

    public class Node

extends java.lang.Object
implements NodeInterface, IfsEventHandler, TimerContext

A Node is a managed CMSDK process.

A Node manages a set of Servers and typically one Service (although a set of Services can be defined).

(Published)

Nested Class Summary
`class` | `Node.NodeRequest` A NodeRequest is structure holding a Node request.

Field Summary

Fields inherited from interface oracle.ifs.core.runtime.NodeInterface
`NODESTATUS_CONFIGURED, NODESTATUS_DISPOSED, NODESTATUS_RUNNING, NODESTATUS_STARTING, NODESTATUS_STOPPED, NODESTATUS_STOPPING, NODESTATUS_UNKNOWN`

Constructor Summary
`Node()` Constructs a Node.

Method Summary
`protected LibrarySession` | `acquireSession()` Acquires a LibrarySession from the session pool.
`void` | `configure(java.lang.String ncName, java.lang.String svcName, AttributeValueTable ncOverrides)` Configure this Node.
`void` | `configure(java.lang.String ncName, java.lang.String svcName, AttributeValueTable ncOverrides, javax.sql.DataSource ds)` Configure this Node, including a DataSource.
`protected LibrarySessionPool` | `constructLibrarySessionPool(int maxSessCount, java.lang.String serviceName, java.lang.String appName, SystemUserCredential cred)` Constructs a LibrarySessionPool.
`protected TimerInterface` | `createTimer()` Creates a Timer.
`protected void` | `disableEventListening()` Disable listening for events on RuntimeState instances.
`void` | `dispose()` Requests to dispose this Node.
`protected void` | `disposeNode()` Disposes this Node.
`protected void` | `disposeService()` Disposes the Service managed by this Node.
`protected void` | `enableEventListening()` Enable listening events on any RuntimeState.
`AttributeValueTable` | `getConfigurationTable()` Gets the Configuration Table for this Node.
`AttributeValue` | `getConfigurationValue(java.lang.String key)` Gets a Configuration value from the Configuration Table for this Node.
`protected java.text.SimpleDateFormat` | `getDateFormat()` Gets the SimpleDateFormat to use for run-timne statistics.
`int` | `getDesiredStatus()` Gets the desired status of this Node.
`java.lang.String` | `getIfsHome()` Gets the CM SDK home directory for this Node.
`java.lang.String` | `getNodeConfigurationName()` Gets the name of the Node Configuration.
`java.lang.String` | `getNodeName()` Gets the name of this Node.
`NodeState` | `getNodeState(LibrarySession session)` Gets the NodeState for this Node.
`java.lang.String` | `getOracleHome()` Gets the Oracle home directory for this Server's node.
`AttributeValueTable` | `getOverridesTable()` Gets the Overrides Table for this Node.
`java.lang.String` | `getServiceConfigurationName()` Gets the name of the Service Configuration.
`java.lang.String` | `getServiceName()` Gets the name that identifies the running Service.
`ServiceState` | `getServiceState(LibrarySession session)` Gets the ServiceState for the service that this Node manages.
`protected LibrarySession` | `getSession()` Gets the session for this Node.
`AttributeValueTable` | `getStateTable()` Gets the State Table for this Node.
`int` | `getStatus()` Gets the status of this Node.
`protected RuntimeState` | `getTargetRuntimeState(LibrarySession session, AuditEvent event)` Gets the RuntimeState instance reflected by the specified event's target object.
`protected AttributeValueTable` | `getTimerConfiguration()` Gets the Timer Configuration.
`protected void` | `handleDisposeNode()` Called when the Node is requested to dispose.
`protected void` | `handleDisposeService()` Called when the Service is requested to dispose.
`void` | `handleEvent(IfsEvent event)` Handles events on RuntimeState objects.
`protected void` | `handleLoadServerRequest(AuditEvent event, NodeState ns)` Handle a request to load a new managed server.
`protected void` | `handleNodeConfigurationOverride(java.lang.String propName)` Handle a NodeConfiguration override.
`protected void` | `handleNodeConfigurationOverrideRequest(AuditEvent event, NodeState ns)` Handle NodeConfiguration overrides that have been posted.
`protected void` | `handleNodeDisposed()` Called as a notification when the Node is disposed.
`protected void` | `handleNodeStateEvent(AuditEvent event, NodeState ns)` Handle a NodeState AuditEvent.
`protected void` | `handleRequest(Node.NodeRequest request)` Handles the specified pending request for this Node.
`protected void` | `handleRequests()` Dispatches any pending requests for this Node.
`protected void` | `handleRestartNode()` Called when the Node is requested to restart.
`boolean` | `handleRuntimeStateEvent(LibrarySession session, AuditEvent event)` Handle a RuntimeState AuditEvent.
`protected boolean` | `handleRuntimeStateEvent(LibrarySession session, AuditEvent event, RuntimeState rs)` Handle a RuntimeState AuditEvent.
`protected void` | `handleServerDisposed(java.lang.String serverName)` Called to process notification that one of the managed Servers has been disposed.
`protected void` | `handleServiceConfigurationOverride(java.lang.String propName, AttributeValue prop)` Handle a ServiceConfiguration override.
`protected void` | `handleServiceConfigurationOverrideRequest(AuditEvent event, ServiceState svs)` Handle ServiceConfiguration overrides that have been posted.
`protected void` | `handleServiceStateEvent(AuditEvent event, ServiceState svs)` Handle a ServiceState AuditEvent.
`protected void` | `handleStartNode()` Called when the Node is requested to start.
`protected void` | `handleStopNode()` Called when the Node is requested to stop.
`protected void` | `handleTimerExpired()` Called when the Node's timer expires.
`protected void` | `initialize()` Initializes this Node.
`protected void` | `initializeLogging()` Initialize logging system, if it is not already initialized, or if "reinitialize" is specified in the Node configuration.
`protected boolean` | `isNodeDisposed()` Indicates the Node has been requested to dispose, and that the run loop should end.
`void` | `postDisposeNodeRequest()` Post request to dispose a node.
`void` | `postDisposeServiceRequest()` Post request to dispose a service.
`void` | `postNodeDisposedRequest()` Post request to indicate that the node is disposed.
`void` | `postNodeStateEventRequest(AuditEvent event)` Post request to handle a Runtime event for our Node.
`protected void` | `postRequest(int type)` Posts a request to this Node, with no AuditEvent and no payload.
`protected void` | `postRequest(int type, AuditEvent event)` Posts a request to this Node, with an AuditEvent.
`protected void` | `postRequest(int type, AuditEvent event, java.lang.Object payload)` Posts a request to this Node, with an AuditEvent and on opaque payload.
`void` | `postRestartNodeRequest()` Post request to restart a node.
`protected void` | `postRun()` Performs post-run tasks for this Node.
`void` | `postServerDisposedRequest(java.lang.String serverName, Server server)` Post request to respond to a Server indicating that it has been disposed.
`void` | `postServerStateEventRequest(AuditEvent event, oracle.ifs.core.runtime.Node.ManagedServer mserver)` Post request to handle a Runtime event for one of our managed Servers.
`void` | `postServiceStateEventRequest(AuditEvent event)` Post request to handle a Runtime event for our Service.
`void` | `postStartNodeRequest()` Post request to start a node.
`void` | `postStopNodeRequest()` Post request to stop a node.
`protected void` | `preRun()` The pre-run tasks for this Node.
`protected void` | `processEvent(IfsEvent event)` Processes an IfsEvent previously placed in this Node's event queue by `queueEvent`.
`protected void` | `processEvents()` Dispatches any IfsEvents previously placed in this Node's event queue by `queueEvent`.
`protected void` | `queueEvent(IfsEvent event)` Queues an IfsEvent for this Node.
`protected void` | `releaseSession()` Releases the Node's session back to the session pool.
`protected void` | `resetTimer()` Resets the timer for this Node.
`void` | `run()` Execute the "Run loop" for this Node.
`protected void` | `setDesiredStatus(int status)` Sets the desired status of this Node.
`protected void` | `setDesiredStatus(int status, boolean force)` Sets the desired status of this Node.
`protected void` | `setStatus(int status)` Sets the status of this Node.
`protected boolean` | `shouldRemovePreviousOverrides()` Gets indication as to whether previous overrides should be applied when restarting a Node.
`void` | `start()` Requests to start the Node.
`protected void` | `startNode()` Starts (or restarts) the Node.
`void` | `startService()` Starts the service associated with this Node.
`protected void` | `startTimer()` Starts a timer that will generate "timer expiration" requests for this Node at a specified interval.
`void` | `stop()` Requests this Node to stop.
`protected void` | `stopNode()` Stops this Node.
`protected void` | `stopTimer()` Stops the timer for this Node.
`void` | `timerExpired()` Notififcation that the timer has expired.
`static java.lang.String` | `toStatusLabel(int status)` Gets a localized label for the specified status of a Node, using a default Localizer.
`static java.lang.String` | `toStatusLabel(int status, LibrarySessionInterface session)` Gets a localized label for the specified status of a Node, using the specified session's Localizer.
`static java.lang.String` | `toStatusLabel(int status, Localizer localizer)` Gets a localized label for the specified status of a Node, using the specified Localizer.
`protected void` | `updateNodeStateLogLevelOverrides()` Update the NodeState with updated LogLevelOverrides information.
`protected void` | `waitNode()` Blocks the current thread until one of the following occurs.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Node

    public Node()
         throws IfsException

  Constructs a Node.

  Subclasses should provide a zero-argument constructor.

  Throws:
    `IfsException` - if the operation fails
  (Published)

Method Detail

### getNodeName

    public java.lang.String getNodeName()

  Description copied from class: `Node`
  Gets the name of this Node.

  Specified by:
    `getNodeName` in interface `NodeInterface`
  Returns:
    the name
  (Published)

### getNodeConfigurationName

    public java.lang.String getNodeConfigurationName()

  Description copied from class: `Node`
  Gets the name of the Node Configuration.

  Specified by:
    `getNodeConfigurationName` in interface `NodeInterface`
  Returns:
    the node configuration name
  (Published)

### getServiceConfigurationName

    public java.lang.String getServiceConfigurationName()

  Description copied from class: `Node`
  Gets the name of the Service Configuration.

  Specified by:
    `getServiceConfigurationName` in interface `NodeInterface`
  Returns:
    the service configuration name
  (Published)

### getServiceName

    public java.lang.String getServiceName()

  Description copied from class: `Node`
  Gets the name that identifies the running Service.

  Specified by:
    `getServiceName` in interface `NodeInterface`
  Returns:
    the service name
  (Published)

### getStatus

    public int getStatus()

  Description copied from class: `Node`
  Gets the status of this Node.

  Specified by:
    `getStatus` in interface `NodeInterface`
  Returns:
    the enumerated status
  (Published)

### getDesiredStatus

    public int getDesiredStatus()

  Description copied from class: `Node`
  Gets the desired status of this Node.

  Specified by:
    `getDesiredStatus` in interface `NodeInterface`
  Returns:
    the enumerated status
  (Published)

### getConfigurationValue

    public AttributeValue getConfigurationValue(java.lang.String key)
                                         throws IfsException

  Description copied from class: `Node`
  Gets a Configuration value from the Configuration Table for this Node.

  Specified by:
    `getConfigurationValue` in interface `NodeInterface`
  Parameters:
    `key` - the configuration property key
  Returns:
    the Configuration value, or null if not defined
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getOracleHome

    public java.lang.String getOracleHome()
                                   throws IfsException

  Description copied from class: `Node`
  Gets the Oracle home directory for this Server's node.

  The Oracle home directory is specified by the Node's `IFS.NODE.OracleHome` property.

  Specified by:
    `getOracleHome` in interface `NodeInterface`
  Returns:
    the Oracle home directory
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getIfsHome

    public java.lang.String getIfsHome()
                                throws IfsException

  Description copied from class: `Node`
  Gets the CM SDK home directory for this Node.

  The CM SDK home directory is specified by the node's `IFS.NODE.IfsHome` property.

  Specified by:
    `getIfsHome` in interface `NodeInterface`
  Returns:
    the CM SDK home directory
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getNodeState

    public NodeState getNodeState(LibrarySession session)
                           throws IfsException

  Description copied from class: `Node`
  Gets the NodeState for this Node.

  Specified by:
    `getNodeState` in interface `NodeInterface`
  Parameters:
    `session` - the session context to use
  Returns:
    the NodeState associated with this Node
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getServiceState

    public ServiceState getServiceState(LibrarySession session)
                                 throws IfsException

  Description copied from class: `Node`
  Gets the ServiceState for the service that this Node manages.

  Specified by:
    `getServiceState` in interface `NodeInterface`
  Parameters:
    `session` - the session context to use
  Returns:
    the ServiceState associated with the Service managed by this Node
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getConfigurationTable

    public AttributeValueTable getConfigurationTable()

  Description copied from class: `Node`
  Gets the Configuration Table for this Node.

  Returns:
    the Configuration Table
  (Published)

### getOverridesTable

    public AttributeValueTable getOverridesTable()

  Description copied from class: `Node`
  Gets the Overrides Table for this Node.

  Returns:
    the Overrides Table
  (Published)

### getStateTable

    public AttributeValueTable getStateTable()

  Description copied from class: `Node`
  Gets the State Table for this Node.

  Returns:
    the State Table
  (Published)

### getDateFormat

    protected java.text.SimpleDateFormat getDateFormat()

  Description copied from class: `Node`
  Gets the SimpleDateFormat to use for run-timne statistics.

  Returns:
    the SimpleDateFormat to use for run-timne statistics
  (Published)

### configure

    public void configure(java.lang.String ncName,
                          java.lang.String svcName,
                          AttributeValueTable ncOverrides)
                   throws IfsException

  Description copied from class: `Node`
  Configure this Node.

  Parameters:
    `ncName` - the name of the NodeConfiguration
    `svcName` - the name of the ServiceConfiguration (can be null)
    `ncOverrides` - the table of NodeConfiguration parameter overrides
  Throws:
    `IfsException` - if the operation fails
  (Published)

### configure

    public void configure(java.lang.String ncName,
                          java.lang.String svcName,
                          AttributeValueTable ncOverrides,
                          javax.sql.DataSource ds)
                   throws IfsException

  Description copied from class: `Node`
  Configure this Node, including a DataSource.

  Parameters:
    `ncName` - the name of the NodeConfiguration
    `svcName` - the name of the ServiceConfiguration (can be null)
    `ncOverrides` - the table of NodeConfiguration parameter overrides
    `ds` - the DatatSource to use in starting the Service
  Throws:
    `IfsException` - if the operation fails
  (Published)

### startService

    public void startService()
                      throws IfsException

  Description copied from class: `Node`
  Starts the service associated with this Node.

  The primary service is defined in the NodeConfiguration. Currently this is picked up from the overrides specified in the `configure` method.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### start

    public void start()
               throws IfsException

  Description copied from class: `Node`
  Requests to start the Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### stop

    public void stop()
              throws IfsException

  Description copied from class: `Node`
  Requests this Node to stop.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### dispose

    public void dispose()
                 throws IfsException

  Description copied from class: `Node`
  Requests to dispose this Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### startNode

    protected void startNode()
                      throws IfsException

  Description copied from class: `Node`
  Starts (or restarts) the Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### shouldRemovePreviousOverrides

    protected boolean shouldRemovePreviousOverrides()
                                             throws IfsException

  Description copied from class: `Node`
  Gets indication as to whether previous overrides should be applied when restarting a Node.

  This is an override point for Node subclasses. It is called within `startNode`, from within the Node's controlled "run loop".

  Returns:
    true if previously applied overrides should be removed as part of Node restart
  Throws:
    `IfsException` - if the operation fails
  (Published)

### initializeLogging

    protected void initializeLogging()
                              throws IfsException

  Description copied from class: `Node`
  Initialize logging system, if it is not already initialized, or if "reinitialize" is specified in the Node configuration.

  Configure LogManager if indicated by settings in the Node configuration.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### initialize

    protected void initialize()
                       throws IfsException

  Description copied from class: `Node`
  Initializes this Node.

  This is an extensibility point, called to allow subclasses perform initialization after the basic initialization occurs by the source that launches the Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### run

    public void run()

  Description copied from class: `Node`
  Execute the "Run loop" for this Node.

  (Published)

### preRun

    protected void preRun()
                   throws java.lang.Exception

  Description copied from class: `Node`
  The pre-run tasks for this Node.

  Extensiblity point for activity prior to the start of the run loop.

  Throws:
    `java.lang.Exception` - if the operation fails
  (Published)

### postRun

    protected void postRun()

  Description copied from class: `Node`
  Performs post-run tasks for this Node.

  Extensiblity point for activity after exiting the run loop.

  (Published)

### isNodeDisposed

    protected boolean isNodeDisposed()

  Description copied from class: `Node`
  Indicates the Node has been requested to dispose, and that the run loop should end.

  Returns:
    whether this Node has been requested to dispose
  (Published)

### startTimer

    protected void startTimer()
                       throws IfsException

  Description copied from class: `Node`
  Starts a timer that will generate "timer expiration" requests for this Node at a specified interval.

  If the timer is already started, it is stopped and restarted.

  Throws:
    `IfsException` - (IFS-45364) if the operation fails
  (Published)

### stopTimer

    protected void stopTimer()
                      throws IfsException

  Description copied from class: `Node`
  Stops the timer for this Node.

  If the timer is not started, this method has no effect.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### resetTimer

    protected void resetTimer()
                       throws IfsException

  Description copied from class: `Node`
  Resets the timer for this Node.

  This has the effect of preventing the next "timer expired" event from occurring until the Activation Period elapses relative to the current time. If the timer is not started, this method has no effect.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### enableEventListening

    protected void enableEventListening()
                                 throws IfsException

  Description copied from class: `Node`
  Enable listening events on any RuntimeState.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### disableEventListening

    protected void disableEventListening()
                                  throws IfsException

  Description copied from class: `Node`
  Disable listening for events on RuntimeState instances.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleEvent

    public void handleEvent(IfsEvent event)
                     throws IfsException

  Description copied from class: `Node`
  Handles events on RuntimeState objects.

  This queues the events for processing inside the run loop.

  Specified by:
    `handleEvent` in interface `IfsEventHandler`
  Parameters:
    `event` - the event to handle
  Throws:
    `IfsException` - if the operation fails
  (Published)

### queueEvent

    protected final void queueEvent(IfsEvent event)
                             throws IfsException

  Description copied from class: `Node`
  Queues an IfsEvent for this Node.

  This is called by the `handleEvent` method of an IfsEventHandler. The event remains in the Node's event queue until `processEvents` is called from within the Node's run loop, at which point `processEvent` is called to process the event.

  Parameters:
    `event` - the event to queue
  Throws:
    `IfsException` - (IFS-45369) if the operation fails
  (Published)

### processEvents

    protected final void processEvents()
                                throws IfsException

  Description copied from class: `Node`
  Dispatches any IfsEvents previously placed in this Node's event queue by `queueEvent`.

  Throws:
    `IfsException` - (IFS-45371) if the operation fails
  (Published)

### processEvent

    protected void processEvent(IfsEvent event)
                         throws java.lang.Exception

  Description copied from class: `Node`
  Processes an IfsEvent previously placed in this Node's event queue by `queueEvent`.

  This method is called by `processEvents`. Override it to perform tasks in response to an event. Unless overridden, no operation is performed by this method.

  The `processEvents` method will rethrow any exception thrown by this method.

  Parameters:
    `event` - the event
  Throws:
    `java.lang.Exception` - if the operation fails
  (Published)

### postRequest

    protected void postRequest(int type)

  Description copied from class: `Node`
  Posts a request to this Node, with no AuditEvent and no payload.

  Parameters:
    `type` - the enumerated request type
  (Published)

### postRequest

    protected void postRequest(int type,
                               AuditEvent event)

  Description copied from class: `Node`
  Posts a request to this Node, with an AuditEvent.

  Parameters:
    `type` - the enumerated request type
    `event` - the AuditEvent associated with this request
  (Published)

### postRequest

    protected void postRequest(int type,
                               AuditEvent event,
                               java.lang.Object payload)

  Description copied from class: `Node`
  Posts a request to this Node, with an AuditEvent and on opaque payload.

  Parameters:
    `type` - the enumerated request type
    `event` - the AuditEvent associated with this request
    `payload` - the additional Object payload
  (Published)

### handleRequests

    protected final void handleRequests()
                                 throws IfsException

  Description copied from class: `Node`
  Dispatches any pending requests for this Node.

  Results in calls to `handleRequest` for each of the queued requests.

  Throws:
    `IfsException` - (IFS-45370) if the operation fails
  (Published)

### handleRequest

    protected void handleRequest(Node.NodeRequest request)
                          throws IfsException

  Description copied from class: `Node`
  Handles the specified pending request for this Node.

  This method can be overridden by subclasses to process custom requests. The implmentation in this base class handles the standard requests, which result in calls to: `handleRequest`, which in turn calls `handleTimerExpired`.

  These calls occur in the same thread that called this method. Should one of these methods throw, request handling will cease, any requests not yet dispatched will remain pending, and this method will rethrow the exception.

  Parameters:
    `request` - the NodeRequest to handle
  Throws:
    `IfsException` - (IFS-45370) if the operation fails
  (Published)

### waitNode

    protected final void waitNode()
                           throws IfsException

  Description copied from class: `Node`
  Blocks the current thread until one of the following occurs.
  - the timer expires
  - a request is posted
  - `queueEvent` is called to enqueue an event

  Throws:
    `IfsException` - (IFS-45372) if the operation fails
  (Published)

### postStartNodeRequest

    public void postStartNodeRequest()

  Description copied from class: `Node`
  Post request to start a node.

  (Published)

### postStopNodeRequest

    public void postStopNodeRequest()

  Description copied from class: `Node`
  Post request to stop a node.

  (Published)

### postRestartNodeRequest

    public void postRestartNodeRequest()

  Description copied from class: `Node`
  Post request to restart a node.

  (Published)

### postDisposeNodeRequest

    public void postDisposeNodeRequest()

  Description copied from class: `Node`
  Post request to dispose a node.

  (Published)

### postNodeDisposedRequest

    public void postNodeDisposedRequest()

  Description copied from class: `Node`
  Post request to indicate that the node is disposed.

  (Published)

### postDisposeServiceRequest

    public void postDisposeServiceRequest()

  Description copied from class: `Node`
  Post request to dispose a service.

  (Published)

### postServiceStateEventRequest

    public void postServiceStateEventRequest(AuditEvent event)

  Description copied from class: `Node`
  Post request to handle a Runtime event for our Service.

  Parameters:
    `event` - the RuntimeState event
  (Published)

### postNodeStateEventRequest

    public void postNodeStateEventRequest(AuditEvent event)

  Description copied from class: `Node`
  Post request to handle a Runtime event for our Node.

  Parameters:
    `event` - the RuntimeState event
  (Published)

### postServerStateEventRequest

    public void postServerStateEventRequest(AuditEvent event,
                                            oracle.ifs.core.runtime.Node.ManagedServer mserver)

  Description copied from class: `Node`
  Post request to handle a Runtime event for one of our managed Servers.

  Parameters:
    `event` - the RuntimeState event
    `mserver` - the managed Server
  (Published)

### postServerDisposedRequest

    public void postServerDisposedRequest(java.lang.String serverName,
                                          Server server)

  Description copied from class: `Node`
  Post request to respond to a Server indicating that it has been disposed.

  Specified by:
    `postServerDisposedRequest` in interface `NodeInterface`
  Parameters:
    `serverName` - the name of the Server that was disposed
    `server` - the Server that was disposed
  (Published)

### timerExpired

    public void timerExpired()

  Description copied from class: `Node`
  Notififcation that the timer has expired.

  Specified by:
    `timerExpired` in interface `TimerContext`
  (Published)

### handleTimerExpired

    protected void handleTimerExpired()
                               throws IfsException

  Description copied from class: `Node`
  Called when the Node's timer expires.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleStartNode

    protected void handleStartNode()
                            throws IfsException

  Description copied from class: `Node`
  Called when the Node is requested to start.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleStopNode

    protected void handleStopNode()
                           throws IfsException

  Description copied from class: `Node`
  Called when the Node is requested to stop.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleRestartNode

    protected void handleRestartNode()
                              throws IfsException

  Description copied from class: `Node`
  Called when the Node is requested to restart.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleDisposeNode

    protected void handleDisposeNode()
                              throws IfsException

  Description copied from class: `Node`
  Called when the Node is requested to dispose.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleNodeDisposed

    protected void handleNodeDisposed()
                               throws IfsException

  Description copied from class: `Node`
  Called as a notification when the Node is disposed.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleDisposeService

    protected void handleDisposeService()
                                 throws IfsException

  Description copied from class: `Node`
  Called when the Service is requested to dispose.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleServerDisposed

    protected void handleServerDisposed(java.lang.String serverName)
                                 throws IfsException

  Description copied from class: `Node`
  Called to process notification that one of the managed Servers has been disposed.

  Parameters:
    `serverName` - the name of the Server that was disposed
  Throws:
    `IfsException` - if the operation fails
  (Published)

### stopNode

    protected void stopNode()
                     throws IfsException

  Description copied from class: `Node`
  Stops this Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### disposeNode

    protected void disposeNode()
                        throws IfsException

  Description copied from class: `Node`
  Disposes this Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### disposeService

    protected void disposeService()
                           throws IfsException

  Description copied from class: `Node`
  Disposes the Service managed by this Node.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### acquireSession

    protected LibrarySession acquireSession()
                                     throws IfsException

  Description copied from class: `Node`
  Acquires a LibrarySession from the session pool.

  Returns:
    the acquired session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getSession

    protected LibrarySession getSession()
                                 throws IfsException

  Description copied from class: `Node`
  Gets the session for this Node.

  Returns:
    the Node's session
  Throws:
    `IfsException` - if the operation fails
  (Published)

### releaseSession

    protected void releaseSession()
                           throws IfsException

  Description copied from class: `Node`
  Releases the Node's session back to the session pool.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### constructLibrarySessionPool

    protected LibrarySessionPool constructLibrarySessionPool(int maxSessCount,
                                                             java.lang.String serviceName,
                                                             java.lang.String appName,
                                                             SystemUserCredential cred)
                                                      throws IfsException

  Description copied from class: `Node`
  Constructs a LibrarySessionPool.

  Parameters:
    `maxSessCount` - the maximum number of sessions that can be constructed by this pool
    `serviceName` - the service name
    `appName` - the application name (for DB connection metadata)
    `cred` - the system user credentials
  Returns:
    the newly constructed LibrarySessionPool
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleRuntimeStateEvent

    public boolean handleRuntimeStateEvent(LibrarySession session,
                                           AuditEvent event)
                                    throws IfsException

  Description copied from class: `Node`
  Handle a RuntimeState AuditEvent.

  Specified by:
    `handleRuntimeStateEvent` in interface `NodeInterface`
  Parameters:
    `session` - the session context of the handler
    `event` - the RuntimeState event
  Returns:
    true if the event was handled by this Node, or can otherwise be ignored by all Nodes
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getTargetRuntimeState

    protected RuntimeState getTargetRuntimeState(LibrarySession session,
                                                 AuditEvent event)
                                          throws IfsException

  Description copied from class: `Node`
  Gets the RuntimeState instance reflected by the specified event's target object.

  Parameters:
    `session` - the session context of the handler
    `event` - the RuntimeState event
  Returns:
    the RuntimeState instance that is the event target
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleRuntimeStateEvent

    protected boolean handleRuntimeStateEvent(LibrarySession session,
                                              AuditEvent event,
                                              RuntimeState rs)
                                       throws IfsException

  Description copied from class: `Node`
  Handle a RuntimeState AuditEvent.

  Parameters:
    `session` - the session context of the handler
    `event` - the RuntimeState event
    `rs` - the RuntimeState instance
  Returns:
    true if the event was handled by this Node, or can otherwise be ignored by all Nodes
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleServiceStateEvent

    protected void handleServiceStateEvent(AuditEvent event,
                                           ServiceState svs)
                                    throws IfsException

  Description copied from class: `Node`
  Handle a ServiceState AuditEvent.

  Parameters:
    `event` - the ServiceState event
    `svs` - the ServiceState instance
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleNodeStateEvent

    protected void handleNodeStateEvent(AuditEvent event,
                                        NodeState ns)
                                 throws IfsException

  Description copied from class: `Node`
  Handle a NodeState AuditEvent.

  Parameters:
    `event` - the NodeState event
    `ns` - the NodeState instance
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleServiceConfigurationOverrideRequest

    protected void handleServiceConfigurationOverrideRequest(AuditEvent event,
                                                             ServiceState svs)
                                                      throws IfsException

  Description copied from class: `Node`
  Handle ServiceConfiguration overrides that have been posted.

  Parameters:
    `event` - the SERVICESTATE_CONFIGURATION_OVERRIDE_REQUESTED event
    `svs` - the ServiceState instance
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleServiceConfigurationOverride

    protected void handleServiceConfigurationOverride(java.lang.String propName,
                                                      AttributeValue prop)
                                               throws IfsException

  Description copied from class: `Node`
  Handle a ServiceConfiguration override.

  Parameters:
    `propName` - the ServiceConfiguration property name
    `prop` - the ServiceConfiguration property value
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleNodeConfigurationOverrideRequest

    protected void handleNodeConfigurationOverrideRequest(AuditEvent event,
                                                          NodeState ns)
                                                   throws IfsException

  Description copied from class: `Node`
  Handle NodeConfiguration overrides that have been posted.

  Parameters:
    `event` - the NODESTATE_CONFIGURATION_OVERRIDE_REQUESTED event
    `ns` - the NodeState instance
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleNodeConfigurationOverride

    protected void handleNodeConfigurationOverride(java.lang.String propName)
                                            throws IfsException

  Description copied from class: `Node`
  Handle a NodeConfiguration override.

  The overridden value can be obtained from the current configuration table.

  Parameters:
    `propName` - the NodeConfiguration property name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### updateNodeStateLogLevelOverrides

    protected void updateNodeStateLogLevelOverrides()
                                             throws IfsException

  Description copied from class: `Node`
  Update the NodeState with updated LogLevelOverrides information.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleLoadServerRequest

    protected void handleLoadServerRequest(AuditEvent event,
                                           NodeState ns)
                                    throws IfsException

  Description copied from class: `Node`
  Handle a request to load a new managed server.

  Parameters:
    `event` - the NODESTATE_LOAD_SERVER_REQUESTED event
    `ns` - the NodeState instance
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setDesiredStatus

    protected void setDesiredStatus(int status)

  Description copied from class: `Node`
  Sets the desired status of this Node.

  Parameters:
    `status` - the new status
  (Published)

### setDesiredStatus

    protected void setDesiredStatus(int status,
                                    boolean force)

  Description copied from class: `Node`
  Sets the desired status of this Node.

  Parameters:
    `status` - the new status
    `force` - if true, set the desired status regardless of the current status
  (Published)

### setStatus

    protected void setStatus(int status)
                      throws IfsException

  Description copied from class: `Node`
  Sets the status of this Node.

  Parameters:
    `status` - the new status
  Throws:
    `IfsException` - if the operation fails
  (Published)

### toStatusLabel

    public static java.lang.String toStatusLabel(int status)
                                          throws IfsException

  Description copied from class: `Node`
  Gets a localized label for the specified status of a Node, using a default Localizer.

  Equivalent to `toStatusLabel(status, null)`.

  Parameters:
    `status` - the status
  Returns:
    the label
  Throws:
    `IfsException` - if the operation fails
  (Published)

### toStatusLabel

    public static java.lang.String toStatusLabel(int status,
                                                 LibrarySessionInterface session)
                                          throws IfsException

  Description copied from class: `Node`
  Gets a localized label for the specified status of a Node, using the specified session's Localizer.

  Equivalent to `toStatusLabel(status, session.getLocalizer())`.

  Parameters:
    `status` - the status
    `session` - the session
  Returns:
    the label
  Throws:
    `IfsException` - if the operation fails
  (Published)

### toStatusLabel

    public static java.lang.String toStatusLabel(int status,
                                                 Localizer localizer)
                                          throws IfsException

  Description copied from class: `Node`
  Gets a localized label for the specified status of a Node, using the specified Localizer.

  If `localizer` is null, this method is equivalent to `toStatusLabel(status, new Localizer())`.

  Parameters:
    `status` - the status
    `localizer` - the Localizer
  Returns:
    the label
  Throws:
    `IfsException` - if the operation fails
  (Published)

### createTimer

    protected TimerInterface createTimer()
                                  throws IfsException

  Description copied from class: `Node`
  Creates a Timer.

  The Timer configuration is hardcoded to run every 5 minutes, with a base time of day of 00:00:00.

  Returns:
    the Timer, or null if the Timer could not be created
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getTimerConfiguration

    protected AttributeValueTable getTimerConfiguration()
                                                 throws IfsException

  Description copied from class: `Node`
  Gets the Timer Configuration.

  Node Subclasses may override this to derive different values for the timer settings.

  Returns:
    the Timer configuration
  Throws:
    `IfsException` - if the operation fails
  (Published)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD